
type TPositionData
  board(1 to 8, 1 to 8) as integer
  activeColor as integer
  castlingAvail as string
  enPassant as string
  halfmoveClock as integer
  fullmoveNum as integer
end type

function BlankPositionData() as TPositionData
  dim result as TPositionData
  for x as integer = 1 to 8
    for y as integer = 1 to 8
      result.board(x, y) = 0
    next y
  next x
  result.activeColor = 0
  result.castlingAvail = ""
  result.enPassant = ""
  result.halfmoveClock = 0
  result.fullmoveNum = 0
  'return result
  function = result
end function

function ParseFEN(aFEN as const string) as TPositionData
  dim as string s(1 to 6), symbol = "kqrbnp PNBRQK", aux
  dim as integer x, y, z
  dim result as TPositionData = BlankPositionData()
  
  aux = aFEN
  z = instr(aux, " ") : s(1) = left(aux, z - 1) : aux = right(aux, len(aux) - z)
  z = instr(aux, " ") : s(2) = left(aux, z - 1) : aux = right(aux, len(aux) - z)
  z = instr(aux, " ") : s(3) = left(aux, z - 1) : aux = right(aux, len(aux) - z)
  z = instr(aux, " ") : s(4) = left(aux, z - 1) : aux = right(aux, len(aux) - z)
  z = instr(aux, " ") : s(5) = left(aux, z - 1) : aux = right(aux, len(aux) - z)
  s(6) = aux
  /'
  for z = 1 to 6
    print s(z)
  next z
  '/
  x = 1
  y = 8
  for z = 1 to len(s(1))
    if s(1)[z - 1] = asc("/") then
      x = 1
      y -= 1
      continue for
    end if
    if (s(1)[z - 1] >= asc("1")) andalso (s(1)[z - 1] <= asc("8")) then
      do while s(1)[z - 1] > asc("0")
        result.board(x, y) = 0
        s(1)[z - 1] -= 1
        x += 1
      loop
      continue for
    end if
    if instr(symbol, chr(s(1)[z - 1])) > 0 then
      result.board(x, y) = instr(symbol, chr(s(1)[z - 1])) - 7
      x += 1
      continue for
    end if
  next z
  
  result.activeColor = iif(s(2) = "w", 1, -1)
  result.castlingAvail = s(3)
  result.enPassant = s(4)
  result.halfmoveClock = valint(s(5))
  result.fullmoveNum = valint(s(6))
  
  'return result
  function = result
end function
