
#libpath ".."
#libpath "..\.."

#include "..\log.bi"
#include "..\mater.bi"
#include "..\jschess\player.bi"
#include "..\rebelbook.bi"
#include "..\validator.bi"

declare function GetMove(positionData as const string) as string
dim shared bookLoaded as boolean

dim FENSample(5) as string = { _
  "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1", _
  "rnbqkbnr/pppppppp/8/8/4P3/8/PPPP1PPP/RNBQKBNR b KQkq e3 0 1", _
  "rnbqkbnr/pp1ppppp/8/2p5/4P3/8/PPPP1PPP/RNBQKBNR w KQkq c6 0 2", _
  "rnbqkbnr/pp1ppppp/8/2p5/4P3/5N2/PPPP1PPP/RNBQKB1R b KQkq - 1 2", _
  "4k3/8/8/8/8/8/4P3/4K3 w - - 5 39", _
  "b7/PP6/8/8/7K/6B1/6N1/4R1bk w KQkq - 5 39" _
}

OpenLog("demo.log")
ToLog(Time())

bookLoaded = (LoadBook() = 0)

for i as integer = 0 to 5
  if IsFEN(FENSample(i)) then
    ToLog(GetMove(FENSample(i)))
  else
    ToLog("Invalid FEN string: """ & FENSample(i) & """")
  end if
next i

if bookLoaded then CloseBook()

CloseLog()

function GetMove(positionData as const string) as string
  const ERRORFLAG = "a1a1"
  dim result as string = ERRORFLAG
  dim moveOk as boolean = false
  
  if BookLoaded then
    result = BookMove(positionData)
    if len(result) = 4 then
      moveOk = true
      ToLog("BookMove")
    else
      CloseBook()
      BookLoaded = false
    end if
  end if
  
  if not moveOk then
    result = *SolveMate(positionData, 3, SEARCH_ALL_MOVES)
    if len(result) = 4 then
      moveOk = true
      ToLog("SolveMate")
    end if
  end if
  
  if not moveOk then
    result = BestMove(positionData)
    if len(result) = 4 then
      moveOk = true
      ToLog("BestMove")
    end if
  end if
  
  return result
end function
