
#include once "log.bi"
#include once "uci.bi"
#include once "rebelbook.bi"
#include once "mater.bi"
#include once "jschess\player.bi"
#include once "chess\chess.bi"
#include once "validator.bi"
#include once "version.bi"

declare function GetMove(byval positionData as string) as string
dim shared bookLoaded as boolean
const STARTPOS = "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"
const ERRORFLAG = "a1a1"

OpenLog("mosquito.log")
ToLog(Time())

bookLoaded = (LoadBook() = 0)
if bookLoaded then
  ToLog("book loaded")
end if

dim as string cmd = "", ss(), fen = STARTPOS, move
dim exitLoop as boolean = false
dim game as chess.tChessGame

while not exitLoop
  Sleep 10
  input "", cmd
  ToLog(cmd)
  
  if uci.IsCommandQuit(cmd) then
    exitLoop = true
  
  elseif uci.IsCommandUCI(cmd) then
    Print("id name " & PROGRAM_NAME & " " & PROGRAM_VERSION)
    Print("id author " & AUTHOR_NAME)
    Print("uciok")
  
  elseif uci.IsCommandReady(cmd) then
    Print("readyok")
  
  elseif uci.IsCommandNewGame(cmd)  then
    fen = STARTPOS
  
  elseif uci.IsCommandPosition(cmd) then
    if uci.IsCommandStartPos(cmd) then
      fen = STARTPOS
      game.Initialize(fen)
      
      if uci.IsCommandMoves(cmd) andalso uci.GetMoves(cmd, ss()) then
        for i as integer = lbound(ss) to ubound(ss)
          game.DoMove(ss(i))
        next i
        fen = game.FEN()
      end if
    elseif uci.IsCommandFEN(cmd) then
      uci.GetFEN(cmd, fen)
    end if
  
  elseif uci.IsCommandGo(cmd) then
    if IsFEN(fen) then
      move = GetMove(fen)
      game.Initialize(fen)
      if game.IsPromotion(move) then
        move += "q"
      end if
    else
      move = ERRORFLAG
      ToLog("Invalid FEN string: """ & fen & """")
    end if
    Print("bestmove " & move)
  end if
wend

if bookLoaded then CloseBook()

CloseLog()

#macro SaveResult(s)
moveOk = true
ToLog(s)
Print("info " & s)
#endmacro

function GetMove(byval positionData as string) as string
  dim result as string = ERRORFLAG
  dim moveOk as boolean = false
  
  if BookLoaded then
    result = BookMove(positionData)
    if len(result) = 4 then
      SaveResult("BookMove")
    else
      result = ERRORFLAG
      CloseBook()
      BookLoaded = false
    end if
  end if
  
  if not moveOk then
    result = *SolveMate(positionData, 3, SEARCH_ALL_MOVES)
    if len(result) = 4 then
      SaveResult("SolveMate")
    else
      result = ERRORFLAG
    end if
  end if
  
  if not moveOk then
    result = BestMove(positionData)
    if len(result) = 4 then
      SaveResult("BestMove")
    else
      result = ERRORFLAG
    end if
  end if
  
  return result
end function
