#include once "Arrows.bas"
#include once "ScrollBar_Basis.bas"

namespace sGUI

declare function AddScrollBar(event as EventHandle ptr,PosX as integer,PosY as integer,SBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer,DisplayMode as integer=0) as Gadget ptr
declare function ScrollBarActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawScrollBar (gad as Gadget ptr)

declare sub ModifyScrollBar overload(gad as Gadget ptr,ScrollValue as integer)
declare sub ModifyScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer)
declare sub ModifyScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
declare sub SetScrollBarVal (gad as Gadget ptr,ScrollValue as integer)
declare sub SetScrollBarLimits(gad as Gadget ptr,Minimum as integer,Maximum as integer)

declare function GetScrollBarVal (gad as Gadget ptr) as integer


'Ctrl(0) "Ablage" des Scrollwertes aus ->gad(0)(dem eigentlichen Scrollbar) im SubHandle
'Ctrl(1) Vergleichswert zu Ctrl(0) bei Unterschied gibt es nen Ping
function AddScrollBar(event as EventHandle ptr,PosX as integer,PosY as integer,SBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer,Orientation as integer,DisplayMode as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=SBLength
    gad->gadh=15
    if Orientation then swap gad->gadw,gad->gadh'Breite und Hhe tauschen wenn vertikal
    gad->Ctrl(0)=ScrollValue
	
    gad->subevent=new EventHandle
		if gad->subevent then

      if Orientation then       'wenn vertikal
        if (DisplayMode=1) or (SBLength-32 < 10) then
          gad->gad(0)=AddSB(gad->subevent,PosX,PosY,gad->gadh,Minimum,Maximum,ScrollValue,PageSize,1)
        else
          gad->gad(0)=AddSB(gad->subevent,PosX,PosY+16,gad->gadh-32,Minimum,Maximum,ScrollValue,PageSize,1)
          gad->gad(1)=AddArrow(gad->subevent, PosX, PosY, 2)
          gad->gad(2)=AddArrow(gad->subevent, PosX, PosY+gad->gadh-16, 3)
        end if
      else                      'wenn horizontal
        if (DisplayMode=1) or (SBLength-32 < 10) then
          gad->gad(0)=AddSB(gad->subevent,PosX,PosY,gad->gadw,Minimum,Maximum,ScrollValue,PageSize,0)
        else
          gad->gad(0)=AddSB(gad->subevent,PosX+16,PosY,gad->gadw-32,Minimum,Maximum,ScrollValue,PageSize,0)
          gad->gad(1)=AddArrow(gad->subevent, PosX, PosY, 0)
          gad->gad(2)=AddArrow(gad->subevent, PosX+gad->gadw-16, PosY, 1)
        end if
      end if
    end if

    gad->DoDraw     =@DrawScrollBar
    gad->DoAction   =@ScrollBarActions
    gad->DoUpdate   =@DrawScrollBar

		'gad->SaveBackGround
		function=gad
  end if
end function



function ScrollBarActions(gad as Gadget ptr,action as integer) as integer
  function=0

  select case action
    case GADGET_HIT,GADGET_HOLD,GADGET_HOLDOFF,GADGET_RELEASE,GADGET_RELEASEOFF',GADGET_MOUSEOVER,GADGET_MOUSENEXT
      	gad->Ctrl(1)=gad->Ctrl(0)
        gad->subevent->GadgetControl
        if gad->subevent->GADGETMESSAGE then
      
        	gad->Ctrl(0)=GetSBVal(gad->gad(0))'egal welches der 3 Controls angeklickt wurde, Scrollbar auslesen
      
          select case gad->subevent->GADGETMESSAGE
      			case gad->gad(1)
              gad->Ctrl(0) -=1
              SetSBVal(gad->gad(0),gad->Ctrl(0))
              gad->Ctrl(0)=GetSBVal(gad->gad(0))
            case gad->gad(0)
      			  'seltsam, beim Bewegen des Scrollbars mu garnichts passieren :D
            case gad->gad(2)
              gad->Ctrl(0) +=1
              SetSBVal(gad->gad(0),gad->Ctrl(0))
              gad->Ctrl(0)=GetSBVal(gad->gad(0))
           end select
        end if
        if gad->ctrl(1)<>gad->Ctrl(0) then
          DrawGadget(gad->gad(0))
          function=1
        end if
  end select
end function



sub DrawScrollBar (gad as Gadget ptr)
  DrawGadget(gad->gad(0))
  if gad->gad(1) then DrawGadget(gad->gad(1))
  if gad->gad(2) then DrawGadget(gad->gad(2))
end sub



sub SetScrollBarVal (gad as Gadget ptr,ScrollValue as integer)
  SetSBVal (gad->gad(0),ScrollValue)
  gad->Ctrl(0)=GetScrollBarVal (gad)
  DrawGadget(gad->gad(0))
end sub



sub SetScrollBarLimits(gad as Gadget ptr,Minimum as integer,Maximum as integer)
  SetSBLimits(gad->gad(0),Minimum,Maximum)
  DrawGadget(gad->gad(0))
end sub



sub ModifyScrollBar (gad as Gadget ptr,ScrollValue as integer)
  SetSBVal (gad->gad(0),ScrollValue)
  gad->Ctrl(0)=GetScrollBarVal (gad)
  DrawGadget(gad->gad(0))
end sub



sub ModifyScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer)
  SetSBLimits(gad->gad(0),Minimum,Maximum)
  DrawGadget(gad->gad(0))
end sub



sub ModifyScrollBar (gad as Gadget ptr,Minimum as integer,Maximum as integer,ScrollValue as integer,PageSize as integer=0)
  SetSBLimits(gad->gad(0),Minimum,Maximum)
  SetSBVal (gad->gad(0),ScrollValue)
  gad->Ctrl(0)=GetScrollBarVal (gad)
  DrawGadget(gad->gad(0))
end sub



function GetScrollBarVal (gad as Gadget ptr) as integer
  function=GetSBVal(gad->gad(0))
end function

end namespace
